// https://eslint.org/docs/user-guide/configuring

module.exports = {
  root: true,
  parserOptions: {
    parser: 'babel-eslint'
  },
  env: {
    browser: true,
  },
  extends: [
    // https://github.com/vuejs/eslint-plugin-vue#priority-a-essential-error-prevention
    // consider switching to `plugin:vue/strongly-recommended` or `plugin:vue/recommended` for stricter rules.
    'plugin:vue/essential',
    // https://github.com/standard/standard/blob/master/docs/RULES-en.md
    'standard'
  ],
  // required to lint *.vue files
  plugins: [
    'vue'
  ],
  // add your custom rules here
  rules: {
    "linebreak-style": ["error", "unix"],
    "quotes": ["error", "single"],
    "semi": ["error", "never"],
    "space-before-function-paren": ["error", "always"],
    "vue/no-unused-vars": "error",
    "prefer-promise-reject-errors": 0,
    "no-eval": 0,
    "no-trailing-spaces": 0,
    "no-throw-literal": 0,
    // "vue/script-indent": ["error", 2],
    // "no-console": 2,
    // "vue/html-indent": [
    //   "error",
    //   2,
    //   {
    //     "attribute": 1,
    //     "closeBracket": 0,
    //     "alignAttributesVertically": true,
    //     "ignores": []
    //   }
    // ],
    "vue/no-parsing-error": [2, { "x-invalid-end-tag": false }],
    "vue/max-attributes-per-line": 0
  }
}
