import Vue from 'vue'
import App from './App'
import VueI18n from 'vue-i18n'
import { Store } from './common'
import VueRouter from 'vue-router'
import Test from './Test'

Vue.config.productionTip = false
Vue.use(VueI18n)
Vue.use(VueRouter)

// 创建Router实例
const router = new VueRouter({
  routes: [
    {
      path: '/',
      name: 'index',
      redirect: '/test'
    },
    {
      path: '/test',
      name: 'test',
      component: Test
    }
  ]
})

/* eslint-disable no-new */
new Vue({
  el: '#app',
  router,
  store: Store.instance,
  components: { App },
  template: '<App/>'
})
