/**
 * Created by WebStorm.
 * User: liulin
 * Date: 2018/12/18
 * Time: 5:16 PM
 */

import IMSDK from 'ciim_sdk'
import { getImInitParams } from '../services/websocket'

const webSocketHost = process.env.WEB_SOCKET_HOST
const imHost = process.env.IM_API_DOMAIN

export default class IM {
  constructor (accountId) {
    this.imParams = this.prepare()
    this.accountId = accountId
  }

  prepare () {
    return getImInitParams(this.accountId)
  }

  async initWebSocket () {
    if (!this.imParams || !this.imParams.token) {
      alert('获取token失败')
      return
    }

    this.$im = new IMSDK.IMService(this.imParams.appkey, this.imParams.app_secret)
    this.$im.init(webSocketHost, `${imHost}/im_api`)
    this.$im.setDebug(true) // 是否开启调试

    this.$im.setConnectListener(() => {
      console.log('连接成功')
    })



    this.$im.setNetFailListener(() => {
      console.log('连接失败，操作将被缓存')
    })

    this.$im.setCustomSysListener((data) => {
      console.log('消息回调', data)
      let receiveData = this.getSocketContent(data)
      if (!receiveData) return

      // USER_ENTER 新用户
      if (receiveData.type === 'USER_ENTER') {
        console.log('有新用户进入了')
        return
      }

      // 这里有空的时候优化一下，这里是先push再排序的，
      // 其实可以在push的时候直接push到正确的位置
      // 那么这里就有多种排序方式了，以后优化的时候搞一个最优的
      this.messageQueue.push(receiveData)
      this.messageQueue = _.sortBy(this.messageQueue, 'newRev')
      if (this.messageQueue.length > 0) this.webSocketMessage(this.messageQueue[0]) // 从消息队列的第一个消息开始执行同步处理
    })
  }
}
